public class SelectionSort implements Sorter {
  public void sort(Comparable[] data) {
    for(int sorted=0; sorted < data.length-1; sorted++) {
      int min = sorted;
      Comparable val = data[min];
      for(int i=sorted+1; i < data.length; i++) {
        if(data[i].compareTo(val) < 0) {
          min = i;
          val = data[min];
        }
      }
      if(sorted != min)
        swap(data, sorted, min);
    }
  } 
  private static void swap(Comparable[] data, int index1, int index2) {
    Comparable dummy = data[index1];
    data[index1] = data[index2];
    data[index2] = dummy;
  }
}